$(document).ready(function () {
  $('#dmn-file-upload').on('change', loadDmnFromFile);
  $('#dmn-file-empty').on('click', loadEmptyFile);
  $('#dmn-file-download').on('click', download);
  // try to load dmn from session
  loadSessionDmn();
});

function loadDmnFromFile(evt) {
  let files = evt.target.files;
  let dmnFile = files[0];
  let fileReader = new FileReader();
  fileReader.onload = function (fileLoadedEvent) {
    let textFromFileLoaded = fileLoadedEvent.target.result;
    openDiagram(textFromFileLoaded);
  };
  fileReader.readAsText(dmnFile, "UTF-8");
}

function loadEmptyFile() {
  $.ajax({
    url: 'dmn/emptyDMN.dmn',
    type: 'GET',
    contentType: 'text/xml',
    success: function (data) {
      openDiagram(data);
    }
  });
}

function download() {
  let dmnXml = exportDiagram();
  console.log("xxx:" + dmnXml);
  if (dmnXml !== undefined) {
    let el = document.createElement('a');
    el.setAttribute('href',
        'data:text/xml;charset=utf-8,' + dmnXml);
    el.setAttribute('download', "dmnTable.dmn");
    el.style.display = 'none';
    document.body.appendChild(el);
    el.click();
    document.body.removeChild(el);
  }
}

let oSerializer = new XMLSerializer();

function loadSessionDmn() {
  $.ajax({
    timeout: 1000,
    url: "/dmn/getdmn",
    type: 'GET',
    contentType: 'text/xml',
    error: function (err) {
      // nothing
      console.log(">-->--> loading session dmn failed. <--<--<");
      // loading empty dmn
      loadEmptyFile();
    },
    success: function (data) {
      let sXML = oSerializer.serializeToString(data);
      openDiagram(sXML);
    }
  });
}

function saveSessionDmn() {
  let dmnXml = exportDiagram();
  $.ajax({
    timeout: 1000,
    url: "/dmn/setdmn",
    type: 'POST',
    contentType: 'text/xml',
    data: dmnXml,
    error: function (err) {
      // nothing
      console.log(">-->--> saving session dmn failed. <--<--<");
    }
  });
}
